Index: code/trunk/src/network/CMakeLists.txt
===================================================================
--- code/trunk/src/network/CMakeLists.txt	(revision 1735)
+++ code/trunk/src/network/CMakeLists.txt	(revision 1740)
@@ -17,5 +17,4 @@
   packet/Gamestate.cc
   packet/Welcome.cc
-  Host.cc
 )
 
Index: code/trunk/src/network/GamestateHandler.h
===================================================================
--- code/trunk/src/network/GamestateHandler.h	(revision 1735)
+++ code/trunk/src/network/GamestateHandler.h	(revision 1740)
@@ -43,12 +43,12 @@
     virtual bool add(packet::Gamestate *gs, int clientID)=0;
     virtual bool ack(int gamestateID, int clientID)=0;
-    
+
     static GamestateHandler *instance_;
-    
-    
+
+
   protected:
     GamestateHandler();
-    ~GamestateHandler();
-    
+    virtual ~GamestateHandler();
+
   public:
     static bool addGamestate(packet::Gamestate *gs, int clientID){ return instance_->add(gs, clientID); }
Index: code/trunk/src/network/GamestateManager.h
===================================================================
--- code/trunk/src/network/GamestateManager.h	(revision 1735)
+++ code/trunk/src/network/GamestateManager.h	(revision 1740)
@@ -70,5 +70,5 @@
     GamestateManager();
     ~GamestateManager();
-    
+
     bool add(packet::Gamestate *gs, int clientID);
     bool processGamestates();
@@ -77,5 +77,5 @@
 
     bool getSnapshot();
-    
+
     bool ack(int gamestateID, int clientID);
     void removeClient(ClientInformation *client);
@@ -83,5 +83,5 @@
     void cleanup(); // "garbage handler"
     bool processGamestate(packet::Gamestate *gs);
-    
+
     std::map<int, packet::Gamestate*> gamestateMap; //map gsID to gamestate*
     std::map<int, int> gamestateUsed; // save the number of clients, that use the specific gamestate
Index: code/trunk/src/network/Host.h
===================================================================
--- code/trunk/src/network/Host.h	(revision 1735)
+++ code/trunk/src/network/Host.h	(revision 1740)
@@ -47,12 +47,12 @@
     virtual unsigned int shipID()=0;
     virtual int playerID()=0;
-    
-    
-    
+
+
+
   protected:
     Host();
-    ~Host();
+    virtual ~Host();
     static Host *instance_;
-    
+
   public:
     static bool running(){return instance_!=0;}
Index: code/trunk/src/network/packet/Gamestate.cc
===================================================================
--- code/trunk/src/network/packet/Gamestate.cc	(revision 1735)
+++ code/trunk/src/network/packet/Gamestate.cc	(revision 1740)
@@ -39,10 +39,10 @@
 
 namespace packet {
-  
+
 
 #define GAMESTATE_START(data) data + sizeof(GamestateHeader)
 #define GAMESTATE_HEADER(data) ((GamestateHeader *)data)
 #define HEADER GAMESTATE_HEADER(data_)
-  
+
 Gamestate::Gamestate()
 {
@@ -64,5 +64,5 @@
   assert(data_==0 /*&& bs_==0*/);
   int size = calcGamestateSize(mode);
-  
+
   COUT(4) << "G.ST.Man: producing gamestate with id: " << id << std::endl;
     //retval->data = (unsigned char*)malloc(size);
@@ -82,5 +82,5 @@
   for(it = orxonox::ObjectList<Synchronisable>::start(); it; ++it){
     tempsize=it->getSize2(mode);
-    
+
     if(currentsize+tempsize > size){
       // start allocate additional memory
@@ -101,9 +101,9 @@
     currentsize+=tempsize;
   }
-  
-  
+
+
   //start write gamestate header
   HEADER->packetType = ENUM::Gamestate;
-  assert( *(ENUM::Type *)(data_) == ENUM::Gamestate); 
+  assert( *(ENUM::Type *)(data_) == ENUM::Gamestate);
   HEADER->normsize = currentsize;
   HEADER->id = id;
@@ -112,5 +112,5 @@
   HEADER->compressed = false;
   //stop write gamestate header
-  
+
   COUT(5) << "G.ST.Man: Gamestate size: " << currentsize << std::endl;
   COUT(5) << "G.ST.Man: 'estimated' (and corrected) Gamestate size: " << size << std::endl;
@@ -125,5 +125,5 @@
     // get the start of the Synchronisable list
   orxonox::Iterator<Synchronisable> it=orxonox::ObjectList<Synchronisable>::start();
-  
+
   while(mem < data_+sizeof(GamestateHeader)+HEADER->normsize){
       // extract synchronisable header
@@ -144,5 +144,5 @@
         it=orxonox::ObjectList<Synchronisable>::end();
       }
-    } else 
+    } else
     {
         // we have our object
@@ -185,5 +185,5 @@
   if(buffer==0)
     return false;
-  
+
   unsigned char *ndata = new unsigned char[buffer+sizeof(GamestateHeader)];
   unsigned char *dest = GAMESTATE_START(ndata);
@@ -192,5 +192,5 @@
   switch ( retval ) {
     case Z_OK: COUT(5) << "G.St.Man: compress: successfully compressed" << std::endl; break;
-    case Z_MEM_ERROR: COUT(1) << "G.St.Man: compress: not enough memory available in gamestate.compress" << std::endl; 
+    case Z_MEM_ERROR: COUT(1) << "G.St.Man: compress: not enough memory available in gamestate.compress" << std::endl;
     return false;
     case Z_BUF_ERROR: COUT(2) << "G.St.Man: compress: not enough memory available in the buffer in gamestate.compress" << std::endl;
@@ -224,5 +224,5 @@
     bufsize = normsize;
   if(bufsize==0)
-    return NULL;
+    return false;
   unsigned char *ndata = new unsigned char[bufsize + sizeof(GamestateHeader)];
   unsigned char *dest = ndata + sizeof(GamestateHeader);
@@ -236,5 +236,5 @@
     case Z_DATA_ERROR: COUT(2) << "data corrupted (zlib)" << std::endl; return false;
   }
-  
+
   HEADER->compressed = false;
   //copy over the header
@@ -245,5 +245,5 @@
   data_ = ndata;
   //bs_ = new Bytestream(getGs(), GAMESTATE_HEADER->normsize);
-  
+
   return true;
 }
@@ -340,5 +340,5 @@
     return HEADER->diffed;
   }
-  
+
   int Gamestate::getBaseID(){
     return HEADER->base_id;