Index: code/trunk/src/network/Client.cc
===================================================================
--- code/trunk/src/network/Client.cc	(revision 1751)
+++ code/trunk/src/network/Client.cc	(revision 1752)
@@ -50,6 +50,6 @@
 {
 //   SetConsoleCommandShortcut(Client, chat);
-  
-  
+
+
   /**
   * Constructor for the Client class
@@ -92,5 +92,5 @@
       closeConnection();
   }
-  
+
   /**
   * Establish the Connection to the Server
@@ -121,9 +121,9 @@
     return client_connection.addPacket(packet);
   }
-  
+
   bool Client::processChat(packet::Chat *message, unsigned int clientID){
     return message->process();
   }
-  
+
   /*bool Client::sendChat(packet::Chat *chat){
     chat->process();
@@ -131,5 +131,5 @@
     return p->send();
   }*/
-  
+
 
   /**
@@ -173,8 +173,8 @@
     if(gameStateID==GAMESTATEID_INITIAL)
       if(gameStateFailure_){
-        packet::Acknowledgement *ack = new packet::Acknowledgement(GAMESTATEID_INITIAL, 0);
+        packet::Acknowledgement *ack = new packet::Acknowledgement((unsigned int)GAMESTATEID_INITIAL, 0);
         if(!ack->send())
           COUT(3) << "could not (negatively) ack gamestate" << std::endl;
-        else 
+        else
           COUT(4) << "negatively acked a gamestate" << std::endl;
         }
Index: code/trunk/src/network/GamestateClient.h
===================================================================
--- code/trunk/src/network/GamestateClient.h	(revision 1751)
+++ code/trunk/src/network/GamestateClient.h	(revision 1752)
@@ -67,5 +67,5 @@
   private:
     packet::Gamestate *processGamestate(packet::Gamestate *gs);
-    void removeObject(orxonox::ObjectList<Synchronisable>::iterator &it);
+    void removeObject(orxonox::ObjectListIterator<Synchronisable> &it);
     void printGamestateMap();
     bool saveShipCache();
Index: code/trunk/src/network/Server.cc
===================================================================
--- code/trunk/src/network/Server.cc	(revision 1751)
+++ code/trunk/src/network/Server.cc	(revision 1752)
@@ -50,4 +50,5 @@
 #include "objects/SpaceShip.h"
 #include "core/ConsoleCommand.h"
+#include "core/CoreIncludes.h"
 #include "core/Iterator.h"
 #include "packet/Chat.h"
Index: code/trunk/src/network/packet/Gamestate.cc
===================================================================
--- code/trunk/src/network/packet/Gamestate.cc	(revision 1751)
+++ code/trunk/src/network/packet/Gamestate.cc	(revision 1752)
@@ -30,4 +30,5 @@
 #include "network/ClientInformation.h"
 #include "network/GamestateHandler.h"
+#include "core/CoreIncludes.h"
 #include "core/Iterator.h"
 
@@ -267,5 +268,5 @@
   assert(HEADER->crc32==calcCRC(ndata+sizeof(GamestateHeader), HEADER->normsize));
 #endif
-  
+
   //copy over the header
   *GAMESTATE_HEADER(ndata) = *HEADER;
@@ -386,5 +387,5 @@
     return HEADER->compressed;
   }
-  
+
   int Gamestate::getBaseID(){
     return HEADER->base_id;
Index: code/trunk/src/network/packet/Gamestate.h
===================================================================
--- code/trunk/src/network/packet/Gamestate.h	(revision 1751)
+++ code/trunk/src/network/packet/Gamestate.h	(revision 1752)
@@ -32,5 +32,4 @@
 #include "util/CRC32.h"
 #endif
-#include "core/CoreIncludes.h"
 
 #ifndef NETWORK_PACKETGAMESTATE_H
@@ -83,5 +82,5 @@
   private:
     unsigned int calcGamestateSize(unsigned int id, int mode=0x0);
-    void removeObject(orxonox::ObjectList<Synchronisable>::iterator &it);
+    void removeObject(orxonox::ObjectListIterator<Synchronisable> &it);
 
 
Index: code/trunk/src/orxonox/Orxonox.cc
===================================================================
--- code/trunk/src/orxonox/Orxonox.cc	(revision 1751)
+++ code/trunk/src/orxonox/Orxonox.cc	(revision 1752)
@@ -54,4 +54,5 @@
 // core
 #include "core/ConfigFileManager.h"
+#include "core/CoreIncludes.h"
 #include "core/Iterator.h"
 #include "core/ConsoleCommand.h"
@@ -185,5 +186,5 @@
         it->setSpeedFactor(it->getSpeedFactor() * change);
 
-    for (Iterator<Backlight> it = ObjectList<Backlight>::begin(); it; ++it)
+    for (ObjectList<Backlight>::iterator it = ObjectList<Backlight>::begin(); it; ++it)
         it->setTimeFactor(Orxonox::getSingleton()->getTimeFactor());
   }